//
//  AppDelegate.h
//  Alexis
//
//  Created by Geronimo on 25/11/15.
//  Copyright © 2015 Foxcom. All rights reserved.
//

#import <UIKit/UIKit.h>

@interface AppDelegate : UIResponder <UIApplicationDelegate>

#define databaseName @"AlexisDB.sql"
#define databaseVersion @"1.0(12)"

#define syncRowCount @"1000"

@property (strong, nonatomic) UIWindow *window;

- (void)createDb;
- (void)deleteDb;
- (BOOL)needFirstSync;
- (NSString *)getSyncTimestamp;
- (void)deleteDataWithVid:(long)dataVid;
- (BOOL)existsDataWithVid:(long)dataVid;
- (NSString *)getDataWithVid:(long)dataVid;
- (void)insertDataWithVid:(long)dataVid Hid:(long)dataHid varianta:(NSString *)dataVarianta variantaBd:(NSString *)dataVariantaBd homonymie:(NSString *)dataHomonymie data:(NSString *)dataData SortOrder:(long)dataSortOrder;
- (void)updateDataWithVid:(long)dataVid Hid:(long)dataHid varianta:(NSString *)dataVarianta variantaBd:(NSString *)dataVariantaBd homonymie:(NSString *)dataHomonymie data:(NSString *)dataData SortOrder:(long)dataSortOrder;
- (void)writeSyncTimestamp:(NSString *)timestamp andStatus:(long)status;
- (void)writeSyncStatus:(long)status;
- (NSString *)getCssMtTimestamp;
- (NSString *)getCssWtTimestamp;
- (NSString *)getCssThtTimestamp;
- (NSString *)getCssIosTimestamp;
- (void)updateCssMtWithTimestamp:(NSString *)timestamp data:(NSString *)data;
- (void)updateCssWtWithTimestamp:(NSString *)timestamp data:(NSString *)data;
- (void)updateCssThtWithTimestamp:(NSString *)timestamp data:(NSString *)data;
- (void)updateCssIosWithTimestamp:(NSString *)timestamp data:(NSString *)data;
- (NSString *)getCssMtData;
- (NSString *)getCssWtData;
- (NSString *)getCssThtData;
- (NSString *)getCssIosData;
- (void)deleteOrder;
- (void)insertOrder:(NSDictionary *)orderDatas;

@end

