//
//  SyncViewController.m
//  Alexis
//
//  Created by Geronimo on 27/11/15.
//  Copyright © 2015 Foxcom. All rights reserved.
//

#import "SyncViewController.h"
#import "AppDelegate.h"

@implementation SyncViewController

#define syncURL @"http://alexis-vyvoj.fox1.cz/portable_device_api.php"

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    
    AppDelegate *app = (AppDelegate*)[[UIApplication sharedApplication] delegate];
    
    syncTimestamp = [app getSyncTimestamp];
    //syncTimestamp = @"2016-01-01 00:00:00";
    syncOffset = 0;
    syncLimit = [syncRowCount integerValue];
    syncStatus = NO;    
    
    timestamp_server = @"";
    
    syncAction = @"css_mt";
    [self getCssWithAction:@"M" timestamp:[app getCssMtTimestamp]];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)getCssWithAction:(NSString *)action timestamp:(NSString *)time {
    NSLog(@"downloading css...");
    NSString *post = [NSString stringWithFormat:@"act=get_css&css_type=%@&timestamp=%@", action, time];
    NSData *postData = [post dataUsingEncoding:NSUTF8StringEncoding allowLossyConversion:YES];
    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] init];
    [request setURL:[NSURL URLWithString:[NSString stringWithFormat:@"%@",syncURL]]];
    [request setHTTPMethod:@"POST"];
    [request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
    [request setHTTPBody:postData];
    
    NSURLConnection *connectionResponse = [[NSURLConnection alloc] initWithRequest:request delegate:self];
    if (!connectionResponse) {
        NSLog(@"Failed to submit request");
    } else {
        NSLog(@"Request submitted");
        responseData = [NSMutableData data];
    }
}

-(void)getOrder {
    NSLog(@"downloading order...");
    NSString *post = [NSString stringWithFormat:@"act=get_order"];
    NSData *postData = [post dataUsingEncoding:NSUTF8StringEncoding allowLossyConversion:YES];
    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] init];
    [request setURL:[NSURL URLWithString:[NSString stringWithFormat:@"%@",syncURL]]];
    [request setHTTPMethod:@"POST"];
    [request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
    [request setHTTPBody:postData];
    
    NSURLConnection *connectionResponse = [[NSURLConnection alloc] initWithRequest:request delegate:self];
    if (!connectionResponse) {
        NSLog(@"Failed to submit request");
    } else {
        NSLog(@"Request submitted");
        responseData = [NSMutableData data];
    }
}

-(void)getChunkWithTimestamp:(NSString *)time offsett:(long)off rowCount:(long)row {
    NSLog(@"downloading chunk...");
    NSString *post;
    if ([time isEqualToString:@""]) {
        post = [NSString stringWithFormat:@"act=get_hesla&OFFSET=%li&ROW_COUNT=%li", off, row];
    } else {
        post = [NSString stringWithFormat:@"act=get_hesla&timestamp=%@&OFFSET=%li&ROW_COUNT=%li", time, off, row];
    }
    NSData *postData = [post dataUsingEncoding:NSUTF8StringEncoding allowLossyConversion:YES];
    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] init];
    [request setURL:[NSURL URLWithString:[NSString stringWithFormat:@"%@",syncURL]]];
    [request setHTTPMethod:@"POST"];
    [request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
    [request setHTTPBody:postData];
    
    NSURLConnection *connectionResponse = [[NSURLConnection alloc] initWithRequest:request delegate:self];
    if (!connectionResponse) {
        NSLog(@"Failed to submit request");
    } else {
        NSLog(@"Request submitted");
        responseData = [NSMutableData data];
    }
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
    NSLog(@"didReceiveResponse");
    NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *)response;
    
    [responseData setLength:0];
    statusCode = [httpResponse statusCode];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    NSLog(@"didReceiveData");
    
    [responseData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
    NSLog(@"Error receiving response: %@", error);
    
    [self finishSync];
    
    UIAlertView *alert;
    alert = [[UIAlertView alloc] initWithTitle:@"Chyba synchronizace" message:@"chyba připojení k internetu" delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil, nil];
    [alert show];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
    AppDelegate *app = (AppDelegate*)[[UIApplication sharedApplication] delegate];
    NSLog(@"didFinishLoading");
    
    //NSString *someString = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
    //NSLog(someString);
    //NSLog([NSString stringWithFormat:@"delka: %i",[responseData length]]);
    
    if (statusCode == 200) {
        if ([syncAction isEqualToString:@"css_mt"]) {
            NSDictionary *css = [self processData:responseData];
            if ([css objectForKey:@"data"] != nil) {
                NSString *css_timestamp = [css objectForKey:@"timestamp"];
                NSData *decodedData = [[NSData alloc] initWithBase64EncodedString:[css objectForKey:@"data"] options:0];
                NSString *css_data = [[NSString alloc] initWithData:decodedData encoding:NSUTF8StringEncoding];
                
                [self processCssData:css_data timestamp:css_timestamp type:@"css_mt"];
            }
            syncAction = @"css_wt";
            [self getCssWithAction:@"W" timestamp:[app getCssWtTimestamp]];
        } else if ([syncAction isEqualToString:@"css_wt"]) {
            NSDictionary *css = [self processData:responseData];
            if ([css objectForKey:@"data"] != nil) {
                NSString *css_timestamp = [css objectForKey:@"timestamp"];
                NSData *decodedData = [[NSData alloc] initWithBase64EncodedString:[css objectForKey:@"data"] options:0];
                NSString *css_data = [[NSString alloc] initWithData:decodedData encoding:NSUTF8StringEncoding];
                
                [self processCssData:css_data timestamp:css_timestamp type:@"css_wt"];
            }
            syncAction = @"css_tht";
            [self getCssWithAction:@"TH" timestamp:[app getCssThtTimestamp]];
        } else if ([syncAction isEqualToString:@"css_tht"]) {
            NSDictionary *css = [self processData:responseData];
            if ([css objectForKey:@"data"] != nil) {
                NSString *css_timestamp = [css objectForKey:@"timestamp"];
                NSData *decodedData = [[NSData alloc] initWithBase64EncodedString:[css objectForKey:@"data"] options:0];
                NSString *css_data = [[NSString alloc] initWithData:decodedData encoding:NSUTF8StringEncoding];
                
                [self processCssData:css_data timestamp:css_timestamp type:@"css_tht"];
            }
            syncAction = @"css_ios";
            [self getCssWithAction:@"IOS" timestamp:[app getCssIosTimestamp]];
        } else if ([syncAction isEqualToString:@"css_ios"]) {
            NSDictionary *css = [self processData:responseData];
            if ([css objectForKey:@"data"] != nil) {
                NSString *css_timestamp = [css objectForKey:@"timestamp"];
                NSData *decodedData = [[NSData alloc] initWithBase64EncodedString:[css objectForKey:@"data"] options:0];
                NSString *css_data = [[NSString alloc] initWithData:decodedData encoding:NSUTF8StringEncoding];
                
                [self processCssData:css_data timestamp:css_timestamp type:@"css_ios"];
            }
            syncAction = @"order";
            [self getOrder];
        } else if ([syncAction isEqualToString:@"order"]) {
            NSDictionary *ord = [self processData:responseData];
            [self processOrderData:ord];
            
            syncAction = @"data";
            [self getChunkWithTimestamp:syncTimestamp offsett:syncOffset rowCount:syncLimit];
        } else if ([syncAction isEqualToString:@"data"]) {
            NSDictionary *chunk = [self processData:responseData];
            NSDictionary *chunk_data = [chunk objectForKey:@"data"];
            long chunk_count = [[chunk objectForKey:@"data_count"] longValue];
            NSString * chunk_timestamp = [chunk objectForKey:@"timestamp_server"];
            
            if ([timestamp_server isEqualToString:@""]) {
                timestamp_server = chunk_timestamp;
            }
            
            //NSLog([NSString stringWithFormat:@"%li",chunk_count]);
            //NSLog([NSString stringWithFormat:@"%li",[chunk_data count]]);
            if (chunk_count == [chunk_data count]) {
            //if (YES) {
                [self processChunkData:chunk_data];
                if (chunk_count > 0) {
                    syncOffset += syncLimit;
                    [self getChunkWithTimestamp:syncTimestamp offsett:syncOffset rowCount:syncLimit];
                } else {
                    syncStatus = YES;
                    [self finishSync];
                    
                    UIAlertView *alert;
                    alert = [[UIAlertView alloc] initWithTitle:@"Synchronizace" message:@"synchronizace dat úspěšně dokončena" delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil, nil];
                    [alert show];
                }
            } else {
                [self finishSync];
                
                UIAlertView *alert;
                alert = [[UIAlertView alloc] initWithTitle:@"Chyba synchronizace" message:@"chyba přenosu dat" delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil, nil];
                [alert show];
            }
        }
    } else {
        [self finishSync];
        
        UIAlertView *alert;
        alert = [[UIAlertView alloc] initWithTitle:@"Chyba synchronizace" message:@"chyba komunikace se serverem" delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil, nil];
        [alert show];
    }
}

- (NSDictionary *)processData:(NSMutableData *)data {
    NSDictionary *results = [NSJSONSerialization JSONObjectWithData:responseData options:0 error:nil];
    return results;
}

- (void)processChunkData:(NSDictionary *)chunkDatas {
    AppDelegate *app = (AppDelegate*)[[UIApplication sharedApplication] delegate];
    for (NSString* key in chunkDatas) {
        NSDictionary *chunkData = [chunkDatas objectForKey:key];
        long chunkDataVid = [[chunkData objectForKey:@"vid"] longValue];
        NSString *chunkDataFlag = [chunkData objectForKey:@"flag"];
        long chunkDataHid = [[chunkData objectForKey:@"id"] longValue];
        NSString *chunkDataVarianta = [chunkData objectForKey:@"varianta"];
        NSString *chunkDataVariantaBd = [chunkData objectForKey:@"varianta_bd"];
        NSString *chunkDataHomonymie = [chunkData objectForKey:@"homonymie"];
        NSString *chunkDataData = [chunkData objectForKey:@"data"];        
        long sortOrder = [[chunkData objectForKey:@"sortorder"] intValue];
        
        if ([chunkDataFlag isEqualToString:@"D"]) {
            [app deleteDataWithVid:chunkDataVid];
        } else if ([chunkDataFlag isEqualToString:@"U"]) {
            if ([app existsDataWithVid:chunkDataVid]) {
                [app updateDataWithVid:chunkDataVid Hid:chunkDataHid varianta:chunkDataVarianta variantaBd:chunkDataVariantaBd homonymie:chunkDataHomonymie data:chunkDataData SortOrder:sortOrder];
            } else {
                [app insertDataWithVid:chunkDataVid Hid:chunkDataHid varianta:chunkDataVarianta variantaBd:chunkDataVariantaBd homonymie:chunkDataHomonymie data:chunkDataData SortOrder:sortOrder];
            }
        }
    }
}

- (void)processCssData:(NSString *)data timestamp:(NSString *)timestamp type:(NSString *)type {
    AppDelegate *app = (AppDelegate*)[[UIApplication sharedApplication] delegate];
    if ([type isEqualToString:@"css_mt"]) {
        [app updateCssMtWithTimestamp:timestamp data:data];
    } else if ([type isEqualToString:@"css_wt"]) {
        [app updateCssWtWithTimestamp:timestamp data:data];
    } else if ([type isEqualToString:@"css_tht"]) {
        [app updateCssThtWithTimestamp:timestamp data:data];
    } else if ([type isEqualToString:@"css_ios"]) {
        [app updateCssIosWithTimestamp:timestamp data:data];
    }
}

- (void)processOrderData:(NSDictionary *)orderDatas {
    AppDelegate *app = (AppDelegate*)[[UIApplication sharedApplication] delegate];
       
    [app deleteOrder];
    [app insertOrder:orderDatas];
}

- (void)finishSync {
    AppDelegate *app = (AppDelegate*)[[UIApplication sharedApplication] delegate];
    
    if (syncStatus) {
        [app writeSyncTimestamp:timestamp_server andStatus:1];
    } else {
        [app writeSyncStatus:0];
    }
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

@end
